/*
 * packet.h
 * (c) pcg@goof.com
 */

#ifndef PACKET_H
#define PACKET_H

#include <unistd.h>

#include <vector>

#include "util.h"

#define MSN_LEN 40

typedef char msn[MSN_LEN+1];
typedef u8 ie_mask;

enum {
	IEM_NONE	= 0x00,	// must be zero
	IEM_BC		= 0x01,
	IEM_CIS		= 0x02,
	IEM_CDS		= 0x04,
	IEM_LLC		= 0x08,
	IEM_HLC		= 0x10,
	
	IEM_ALL		= 0xff,
	IEM_MIN		= IEM_BC
};

struct packet : vector<u8> {
  ie_mask mask; // which information elements to use / received
  msn src_msn;
  msn dst_msn;
  
  timestamp time;
  
  bool operator() () const { return !empty (); };
  void put(u8 b) { push_back (b); };
  void reset() { erase (begin (), end ()); dst_msn[0] = src_msn[0] = 0; };
  void set(const char *src, const char *dst, ie_mask m)
     { time.stamp (); mask = m; strcpy (src_msn, src); strcpy (dst_msn, dst); erase (begin (), end ()); };
  u8 get() { u8 r = front (); erase (begin ()); return r; }; // hyper-inneffektiv...
  
  packet () { strcpy (dst_msn, "xxxx"); };
  packet (const char *src, const char *dst, ie_mask pmask = IEM_ALL);
  packet (const char *p); // create a packet from a "PACKET: " line
  
  // why the h*** are these needed??
  packet (const packet &p);
  const packet &operator =(const packet &p);
  
  operator const char * () const;
};

extern int packet_length (ie_mask mask); // maximum length with respect to mask in *bytes*

extern void normalize_msn (char *number); // normalize local number

#endif


